<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="shortcut icon" type="image/x-icon" href="images/dice.ico">
  <title>F200 - Lịch sử quay Dice</title>

  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.5/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.5/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.5/js/dataTables.bootstrap4.min.js"></script>
  <style>
    .custom-background-first-container {
      background: #F2F2F2;
    }

    input {
      background: #5A9BD5;
      color: white;
    }

    input::placeholder {
      color: white;
      font-weight: 400;
    }

    table thead {
      background: #5A9BD5;
      color: white;
    }

    tbody tr {
      font-weight: 600;
    }
  </style>
</head>

<body>
  <!-- Task 43.40 -->
  <div class="container">
    <div class="text-center mt-4 mb-2">
      <h3>F200 - LỊCH SỬ QUAY DICE</h3>
    </div>
    <div class="container mt-3 mb-5 p-5 custom-background-first-container">
      <div class="row">
        <div class="col-12">
          <h4 class="font-weight-bold">Thông tin người chơi</h4>
        </div>
        <div class="col-4">
          <input id="inp-username" type="text" placeholder="Username">
        </div>
        <div class="col-4">
          <input id="inp-firstname" type="text" placeholder="Firstname">
        </div>
        <div class="col-4">
          <input id="inp-lastname" type="text" placeholder="Lastname">
        </div>
      </div>
    </div>
  </div>

  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="dice-history-table">
      <thead>
        <tr>
          <th>Lần chơi</th>
          <th>Kết quả</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
  </div>
</body>
<script>
  "use strict"
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
  const gUSER_TABLE_PAGE = "task 43.30 Filter User Table v2.1.html";

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    // gọi hàm sự kiện xử lý khi load trang
    onPageLoading();
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm sự kiện thực thi khi trang được load
  function onPageLoading() {
    // 0. Khai báo và khởi tạo data
    var vUser = {
      userId: 0,
      userName: "",
      firstName: "",
      lastName: ""
    }
    // 1. Thu thập dữ liệu từ query string
    readUserDataFromQueryString(vUser);
    // 2. Kiểm tra dữ liệu
    var vIsValid = validateQueryString(vUser);
    if (vIsValid) {
      // 3. gọi api (server)
      callAPIToGetHistoryDice(vUser.userName);
      // 4. xứ lý hiển thi dữ liệu (thực hiện ở hàm displayDiceHistory và xử lý hiển thị)
    }
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
  // hàm đọc dữ liệu được truyền trên query string
  function readUserDataFromQueryString(paramUser) {
    // Get data from query string
    var vUrlString = window.location.href;
    var vUrl = new URL(vUrlString);
    // Get parameters
    var vId = vUrl.searchParams.get("id");
    var vUsername = vUrl.searchParams.get("username");
    var vFirstname = vUrl.searchParams.get("firstname");
    var vLastname = vUrl.searchParams.get("lastname");

    // gán nội dung cho đối tượng User truyền vào
    paramUser.userId = vId;
    paramUser.userName = vUsername;
    paramUser.firstName = vFirstname;
    paramUser.lastName = vLastname;
    // gán nội dung cho các thẻ input
    $("#inp-username").val(vUsername);
    $("#inp-firstname").val(vFirstname);
    $("#inp-lastname").val(vLastname);
  }

  // hàm kiểm tra dữ liệu được truyền từ query string
  function validateQueryString(paramUser) {
    var vIsValid = true;
    if (paramUser.userId == null || paramUser.userName == null || paramUser.firstName == null || paramUser.lastName == null) {
      alert("Các thông tin của User không hợp lệ!");
      window.location.href = gUSER_TABLE_PAGE;
      vIsValid = false;
    }
    return vIsValid;
  }

  // hàm call api để lấy danh sách lịch sử quay xúc xắc
  function callAPIToGetHistoryDice(paramUsername) {
    $.ajax({
      url: gBASE_URL + "/dice-history?username=" + paramUsername,
      type: 'GET',
      dataType: 'json',
      success: function (res) {
        console.log("Danh sách lịch sử quay xúc xắc: ...");
        console.log(res);
        displayDiceHistory(res);
      },
      error: function (ajaxContext) {
        alert(ajaxContext.status);
      }
    });
  }

  // hàm xử lý hiển thị khi lấy thành công Lịch sử quay xúc xắc
  function displayDiceHistory(paramResDiceHistory) {
    var vTBody = $("#dice-history-table tbody");
    // dùng vòng lặp for để tạo mỗi dòng cho table
    for (let bI = 0; bI < paramResDiceHistory.dices.length; bI++) {
      let vDiceHistory = paramResDiceHistory.dices[bI];
      // Tạo dòng mới cho bảng và ghi vào các giá trị
      var vRow = $("<tr></tr>");
      // Thêm từng ô trên mỗi dòng
      var vCellPlayRound = $("<td></td>");
      var vCellResult = $("<td></td>");
      // Gán giá trị vào từng thuộc tính của mỗi ô trên mỗi dòng
      vCellPlayRound.text(bI + 1);
      vCellResult.text(vDiceHistory);
      // Chèn các ô vào dòng
      vRow.append(vCellPlayRound);
      vRow.append(vCellResult);
      // Chèn dòng vào tbody của bảng
      vTBody.append(vRow);
    }
  }
</script>

</html>